﻿;***********************************************************************
;Simple testing programme for PurePrint module
;Only an example
;Run This code to get all the rest
;
;***********************************************************************

;Only uses .jpg images
UseJPEGImageDecoder()

;Ensure these are included
IncludeFile "App.pbi"
IncludeFile "CDPrint.pbi"

Structure Page
  Height.i
  Width.i
  Orientation.i
  TopMargin.i
  LeftMargin.i
  BottomMargin.i
  RightMargin.i
EndStructure

Global Dim Pages.Page(1)

Global Window_0
Global PageHeight
Global PageWidth
Global TopMargin
Global LeftMargin
Global BottomMargin
Global RightMargin
Global PageSetup
Global image.l
Global btnPreview,btnPrint
Global Print.l
Global btnPageSetup, txt_PageHeight, txt_PageWidth, str_TopMargin, str_LeftMargin, str_BottomMargin, str_PageWidth, str_RightMargin, str_PageHeight, txt_TopMargin, txt_LeftMargin, txt_BottomMargin, txt_RightMargin, btn_Exit

  ;Open the test window

  Window_0 = OpenWindow(#PB_Any, x, y, 250, 340, "", #PB_Window_SystemMenu)
  btnPageSetup = ButtonGadget(#PB_Any, 20, 10, 100, 30, "Page Setup")
  btnPreview = ButtonGadget(#PB_Any, 130, 10, 50, 30, "Preview")
  DisableGadget(btnPreview, 1)
  btnPrint = ButtonGadget(#PB_Any, 190, 10, 50, 30, "Print")
  DisableGadget(btnPrint, 1)
  btn_Exit = ButtonGadget(#PB_Any, 65, 280, 120, 40, "Quit")
  txt_PageHeight = TextGadget(#PB_Any, 50, 60, 80, 20, "Page Height", #PB_Text_Right)
  txt_PageWidth = TextGadget(#PB_Any, 60, 90, 70, 20, "Page Width", #PB_Text_Right)
  str_TopMargin = StringGadget(#PB_Any, 140, 120, 60, 20, "")
  str_LeftMargin = StringGadget(#PB_Any, 140, 150, 60, 20, "")
  str_BottomMargin = StringGadget(#PB_Any, 140, 180, 60, 20, "")
  str_PageWidth = StringGadget(#PB_Any, 140, 90, 60, 20, "")
  str_RightMargin = StringGadget(#PB_Any, 140, 210, 60, 20, "")
  str_PageHeight = StringGadget(#PB_Any, 140, 60, 60, 20, "")
  txt_TopMargin = TextGadget(#PB_Any, 60, 120, 70, 20, "Top Margin", #PB_Text_Right)
  txt_LeftMargin = TextGadget(#PB_Any, 50, 150, 80, 20, "Left Margin", #PB_Text_Right)
  txt_BottomMargin = TextGadget(#PB_Any, 40, 180, 90, 20, "Bottom Margin", #PB_Text_Right)
  txt_RightMargin = TextGadget(#PB_Any, 50, 210, 80, 20, "Right Margin", #PB_Text_Right)
  str_Orientation = StringGadget(#PB_Any, 140, 240, 60, 20, "")
  
  
  ;Test Purposes Only normally set by your programme
  ReDim Pages(2)
  Pages(0)\Height = 297    ;A4 Page Height
  Pages(0)\Width = 210     ;A4 Page Width
  Pages(0)\Orientation = 1 ;Portrait
  Pages(0)\TopMargin = 15
  Pages(0)\LeftMargin = 15
  Pages(0)\BottomMargin = 15
  Pages(0)\RightMargin = 15
  Pages(1)\Height = 297    ;A4 Page Height
  Pages(1)\Width = 210     ;A4 Page Width
  Pages(1)\Orientation = 0 ;Landscape
  Pages(1)\TopMargin = 15
  Pages(1)\LeftMargin = 15
  Pages(1)\BottomMargin = 15
  Pages(1)\RightMargin = 15
  ;Test Purposes Only
  
  
  Procedure PrintPages()
  
    ;****************************************************
    ;Procedure just to test print a couple of pages
    ;Replace with your own procedure
    ;Normally is a loop through all document commands
    ;Checking height of page left etc
    ;Allways check as landscape has a smaller height
    ;
    ;Looking to add a Print which pages dialog at some 
    ;point To allow users To choose which pages To print
    ; This is where the call to that dialog will go
    ;
    ;****************************************************
 
    For i = 0 To   1  ;Just two pages to test
    
     
      ;Set Page Properties
      TopMargin = Pages(i)\TopMargin
      LeftMargin = Pages(i)\LeftMargin 
      BottomMargin = Pages(i)\BottomMargin    
      RightMargin = Pages(i)\RightMargin  
     
      If Pages(i)\Orientation = 1
        
        CDPrint::Orientation = 1        
        PageHeight = Pages(i)\Height
        PageWidth = Pages(i)\Width
         
      Else
        
        CDPrint::Orientation = 0
        PageHeight = Pages(i)\Width
        PageWidth = Pages(i)\Height
        
      EndIf
      
      ;Check if Print Started If Not Start The Print Job
      If Print = 0
        
        Print = CDPrint::open("Test",PageHeight,PageWidth)
        If Print = 0
          Debug "Cancelled"
          ProcedureReturn
        EndIf
          
      Else
        
        CDPrint::AddPage(PageHeight,PageWidth)
        
      EndIf

      ;Print A Border around the margins
      CDPrint::PrintBox(LeftMargin,RightMargin ,PageWidth - RightMargin ,PageHeight - BottomMargin,1)
   
      ;Print A Line 3mm Thick
      CDPrint::PrintLine(20,50,PageWidth -20,50,3)

      ;Print some text
      FontName$ = "Arial"   ; set initial font  (could also be blank)
      FontSize  = 14        ; set initial size  (could also be null)
      Result = FontRequester(FontName$, FontSize, #PB_FontRequester_Effects)
      CDPrint::PrintText(50,100,SelectedFontName(),SelectedFontSize(),"Just Testing Page "+ Str(i + 1))
      
      ;Print some Centered Text
      text$ = "Just Testing Centered"
      widthtext.i = CDPrint::GettextWidthmm(text$,SelectedFontName(),SelectedFontSize())
      x.i = (PageWidth - LeftMargin - RightMargin - widthtext.i)/2
      CDPrint::PrintText(x.i + LeftMargin,130,SelectedFontName(),SelectedFontSize(),"Just Testing Centered")

      ;Select image to print for this page
      ;Remember to add decoders needed for image type
      image$ = OpenFileRequester("SELECT IMAGE","","All supported formats|*.bmp;*.jpg; *.jpeg; *.wmf; *.emf; *.png;*.tif;*.tiff;*.tga|TGA image (*.tga)|*.tga|TIF image (*.tif)|*.tif|TIFF image (*.tiff)|*.tiff|PNG image (*.png)|*.png|BMP image (*.bmp)|*.bmp|JPEG image (*.jpg;*.jpeg)|*.jpg;*.jpeg|GIF image (*.gif)|*.gif",0)
      If image$ <> ""
                
        Image.l=LoadImage(#PB_Any, image$)

      EndIf
    
      If Image.l > 0
      
        ; Remember ImageVectorOutput automatically scales the image so maintain aspect ratio
        If ImageHeight(image.l) > ImageWidth(image.l)
          adjustedheight = 50 * (ImageHeight(image.l)/ImageWidth(image.l))
          adjustedwidth = adjustedheight * ImageWidth(image.l) / ImageHeight(image.l)
        Else
          adjustedwidth = 40 * (ImageWidth(image.l)/ImageHeight(image.l))
          adjustedheight = adjustedwidth * ImageHeight(image.l)/ImageWidth(image.l)
        EndIf
    
        ;Depending on the image you may have to use the adjusted height in page calculations
        ;The image is allways drawn starting from top left so the position of an adjusted image may need to be changed
        ;to provide bottom aligned image printing or as here to make sure the image prints on the page
        Define Topy.i = 150

        If (Topy + adjustedheight ) > (Pageheight - BottomMargin)
          ;Move the image up to just squeeze it on the page inside the margin
          Topy = Topy - ((Topy + adjustedheight ) - (Pageheight - BottomMargin) )
        EndIf
        CDPrint::PrintImage(Image.l,40,Topy,adjustedwidth,adjustedheight)
        
      EndIf
  
    Next i
    
    ;Finish The Print Job
    CDPrint::Finished()

EndProcedure
  
  Repeat
    
    Event = WaitWindowEvent() 
    
    If EventWindow() = Print.l
      
      CDPrint::CDPrintEvents(event)
      
    EndIf
   

  Select event

    Case #PB_Event_Gadget
      Select EventGadget()
          
        Case btnPageSetup
          
          CDPrint::Page_Setup()
          SetGadgetText(str_PageHeight,Str(CDPrint::PageHeight))
          SetGadgetText(str_PageWidth,Str(CDPrint::PageWidth))  
          SetGadgetText(str_TopMargin,Str(CDPrint::TopMargin))
          SetGadgetText(str_LeftMargin,Str(CDPrint::LeftMargin))           
          SetGadgetText(str_BottomMargin,Str(CDPrint::BottomMargin))
          SetGadgetText(str_RightMargin,Str(CDPrint::RightMargin))          
          If CDPrint::Orientation = 1
            SetGadgetText(str_Orientation,"Portrait") 
          Else
            SetGadgetText(str_Orientation,"Landscape")  
          EndIf
          If CDPrint::PageHeight > 0 And CDPrint::PageWidth > 0
            DisableGadget(btnPreview, 0)
            DisableGadget(btnPrint, 0)
          EndIf
          ;Set your page variables here
          ;e.g.   Pages(1)\TopMargin = CDPrint::TopMargin  etc
          
        Case btnPreview
          
          CDPrint::Preview.i = 1 ; Set to preview document
          PrintPages()
          CDPrint::ShowPage(0)
          
        Case btnPrint
          
          CDPrint::Preview.i = 0 ; Set to print document
          PrintPages()
               
        Case btn_Exit
          
          End
          
      EndSelect
      
  EndSelect

Until EventWindow() = Window_0 And Event = #PB_Event_CloseWindow  ; If the user has pressed on the window close button
End
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 127
; FirstLine = 122
; Folding = -
; EnableUnicode
; EnableXP